<div ng-if="data.waitingPromise">
    <h3><img src="/public/img/loading-pulse.svg" /> Loading...</h3>
</div>

<nav ng-if="!data.waitingPromise">
    <div class="page-header">
        <h1 class="page-heading">Choose a Network</h1>
    </div>
    <div class="gf-form-inline">
        <div class="gf-form">
            <label class="gf-form-label width-10" for="networks">Network</label>
            <select name="networks" id="networks" class="gf-form-input min-width-15" ng-options="network as network.name for network in data.networkList"
                    ng-model="data.networkToFind" ng-change="setNetworkSelected()">
                <option value="" disabled selected hidden>Choose network</option>
            </select>
        </div>
    </div>
    <div id="editNetworkGraph" class="gf-form-inline" ng-bind-html="data.graphHtml"></div>
</nav>
<div id="gnb" class="gf-form-group" ng-if="data.graphHtml">
    <div class="gf-form-inline style_tab">
        <ul class="gf-tabs page-header__tabs">
            <li class="gf-tabs-item">
                <a class="gf-tabs-link" ng-class="{active: data.tab == 0}" href ng-click="setTab(0)">
                    <i class="gicon gicon-home"></i>General
                </a>
            </li>
            <li class="gf-tabs-item">
                <a class="gf-tabs-link" ng-class="{active: data.tab == 1}" href ng-click="setTab(1)">
                    <i class="gicon gicon-manage"></i>
                    Modify Node
                </a>
            </li>
            <li class="gf-tabs-item">
                <a class="gf-tabs-link" ng-class="{active: data.tab == 2}" href ng-click="setTab(2)">
                    <i class="gicon gicon-manage"></i>
                    Add Node
                </a>
            </li>
            <li class="gf-tabs-item">
                <a class="gf-tabs-link" ng-class="{active: data.tab == 3}" href ng-click="setTab(3)">
                    <i class="gicon gicon-manage"></i>
                    Delete Node
                </a>
            </li>
        </ul>
    </div>

    <!-- TAB GENERAL -->
    <form name="general" ng-if="data.tab == 0">
        <div class="gf-form-inline">
            <div class="gf-form">
                <label class="gf-form-label width-10">Network name
                    <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                        Begin with one <b>letter</b> or <b>underscore</b>, followed by zero or more <b>digits</b>, <b>letters</b> and <b>underscores</b>.
                    </info-popover>
                </label>
                <input type="text" ng-pattern="/^[a-zA-Z_][0-9a-zA-Z_]*$/" class="gf-form-input max-width-15" ng-model="data.networkSelected.name" required>
            </div>
        </div>
        <div class="gf-form-inline">
            <div class="gf-form">
                <label class="gf-form-label width-10">Refresh Time (ms)</label>
                <input type="text" ng-pattern="/^[0-9]{1,}$/" class="gf-form-input max-width-15" ng-value="data.originalNetwork.refreshTime" ng-model="data.networkSelected.refreshTime" required>
            </div>
        </div>
        <div class="gf-form-inline">
            <div class="gf-form">
                <label class="gf-form-label width-10" for="db_dest">Dest. database
                    <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                        This is the database where the network will be saved. A table will be created with the name <b>{{data.originalNetwork.name}}[{{data.originalNetwork.id}}]</b>
                    </info-popover>
                </label>
                <select name="db_dest" id="db_dest" class="gf-form-input min-width-15"
                        ng-model="data.databaseSelected"
                        ng-options="database as database.grafanaName for database in data.databaseList"
                        required>
                    --<option value="" disabled selected hidden>Choose database</option>
                </select>
            </div>
        </div>
        <div class="gf-form-button-row">
            <input type="submit" ng-disabled="general.$invalid" class="btn btn-success" ng-click="updateNetworkGeneralData()" value="Save" />
        </div>
    </form>

    <!-- TAB MODIFY NODE -->
    <div ng-if="data.tab == 1">
        <div class="page-header">
            <h3 class="page-heading">Select a node to modify</h3>
        </div>
        <div class="gf-form-inline">
            <div class="gf-form">
                <label class="gf-form-label width-9">Node</label>
                <select class="min-width-10" name="nodes" ng-options="node as node.name for node in data.originalNetwork.nodes" ng-model="data.originalNode"
                        ng-change="setExistingData()">
                    <option value="" disabled selected hidden>Choose node</option>
                </select>
            </div>
            <br/>
        </div>
        <div ng-if="data.nodeSelected">
            <div class="page-header">
                <h3 class="page-heading">General</h3>
            </div>

            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label width-9" for="name">Name
                        <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                            Begin with one <b>letter</b> or <b>underscore</b>, followed by zero or more <b>digits</b>, <b>letters</b> and <b>underscores</b>.
                        </info-popover>
                    </label>
                    <input type="text" id="name" ng-pattern="/^[a-zA-Z_][0-9a-zA-Z_]*$/" class="gf-form-input min-width-10" ng-model="data.nodeSelected.name" placeholder="Node name">
                </div>
            </div>

            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label width-9 multiple">Predecessors
                        <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                            Press and hold <kbd>ctrl</kbd> or <kbd>shift</kbd> and <kbd>click</kbd> on the node to select multiple nodes.
                        </info-popover>
                    </label>
                    <select class="min-width-10" name="predecessors" ng-options="node as node.name for node in data.originalNetwork.nodes | filter: filterNode" ng-model="data.predecessorList" ng-change="createCpt(); populateProbabilities()" multiple>
                        <option value="" disabled selected hidden>Choose predecessors</option>
                    </select>
                </div>

                <div class="gf-form">
                    <label class="gf-form-label width-9 multiple">Successors
                        <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                            Press and hold <kbd>ctrl</kbd> or <kbd>shift</kbd> and <kbd>click</kbd> on the node to select multiple nodes.
                        </info-popover>
                    </label>
                    <select class="min-width-10" name="successors" ng-options="node as node.name for node in data.originalNetwork.nodes | filter: filterNode" ng-model="data.successorList" multiple>
                        <option value="" disabled selected hidden>Choose successors</option>
                    </select>
                </div>
            </div>

            <div class="page-header">
                <h3 class="page-heading">States
                    <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                        <b>States number</b> indicate the number of states that will be created.<br/>
                        <b>Min</b> and <b>Max</b> are the thresholds.<br/>
                        If <b>Min</b> and <b>Max</b> are filled, the range is <b>Min&lt;X&lt;Max</b>.
                        If only <b>Min</b> is filled, the range is <b>Min&lt;X</b>.
                        If only <b>Max</b> is filled, the range is <b>X&lt;Max</b>.
                    </info-popover>
                </h3>
            </div>
            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label width-8">States number</label>
                    <input type="number" class="gf-form-input width-5" ng-model="data.numberStates" ng-change="populateStateList(); populateProbabilities()" placeholder="num">
                </div>
            </div>
            <div class="gf-form-inline" ng-repeat="index in range(data.numberStates) track by $index">
                <div class="gf-form">
                    <label class="gf-form-label width-8" for="name">Name
                        <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                            Begin with one <b>letter</b> or <b>underscore</b>, followed by zero or more <b>digits</b>, <b>letters</b> and <b>underscores</b>.
                        </info-popover>
                    </label>
                    <input type="text" ng-pattern="/^[a-zA-Z_][0-9a-zA-Z_]*$/" class="gf-form-input min-width-10" placeholder="State name" ng-model="data.stateList[$index].name">
                </div>
                <div class="gf-form">
                    <label class="gf-form-label width-4">Min</label>
                    <input type="number" class="gf-form-input width-5" placeholder="min" ng-model="data.stateList[$index].minInterval">
                </div>
                <div class="gf-form">
                    <label class="gf-form-label width-4">Max</label>
                    <input type="number" class="gf-form-input width-5" placeholder="max" ng-model="data.stateList[$index].maxInterval">
                </div>
            </div>

            <div class="page-header">
                <h3 class="page-heading">Probability table
                    <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                        By selecting the predecessors of the node, a grid will be created with the options to set the probabilities of each state.
                    </info-popover>
                </h3>
            </div>
            <table class="table table-bordered table-dark" > <!-- ||  -->
                <thead ng-if="data.stateListCpt.length > 0">
                <tr ng-repeat="i in range(data.stateListCpt.length) track by $index" ng-init="row = $index">
                    <th>{{data.stateListCpt[row].nodeName}}</th>
                    <th colspan="{{getStateList(data.stateListCpt.length-1).length/getStateList(row).length}}" ng-repeat="j in getStateList(row) track by $index" ng-init="column = $index">{{getStateList(row)[column].name}}</th>
                </tr>
                </thead>

                <tbody ng-if="data.numberStates !== 0 || data.numberStates !== null">
                <tr ng-repeat="index in range(data.numberStates) track by $index" ng-init="row = $index">
                    <th scope="row">{{data.stateList[$index].name}}</th>
                    <td ng-repeat="j in range(getStateList(data.stateListCpt.length-1).length) track by $index" ng-init="column = $index">
                        <input type="number" class="gf-form-input" ng-model="data.probabilities[row][column]" placeholder="Ex: 0.5">
                    </td>
                </tr>
                </tbody>
            </table>


            <div class="page-header">
                <h3 class="page-heading">Sensor info</h3>
            </div>
            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label  width-9">Data Source
                        <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                            <b>OPTIONAL:</b> This is the <b>database</b>, <b>table</b> and <b>column</b> used as the source of data by the selected node.
                        </info-popover>
                    </label>
                    <select name="databases"
                            ng-options="database as database.grafanaName for database in data.databaseList" ng-model="data.databaseSelected"
                            ng-change="setTableList()">
                        <option value="" disabled selected hidden>Choose database</option>
                    </select>
                    <div ng-if="data.waitingSensor && data.databaseSelected">
                        <h3><img src="/public/img/loading-pulse.svg" /> Loading...</h3>
                    </div>
                    <div ng-if="!data.waitingSensor && data.tables.length > 0">
                        <select name="tables" ng-options="table for table in data.tables" ng-model="data.tableSelected"
                                ng-change="setColumnList()">
                            <option value="" disabled selected hidden>Choose table</option>
                        </select>

                        <select name="columns" ng-options="column for column in data.columns"
                                ng-model="data.columnSelected">
                            <option value="" disabled selected hidden>Choose column</option>
                        </select>
                    </div>
                    <div ng-if="!data.waitingSensor && !(data.tables.length > 0) && data.databaseSelected" class="alert alert-warning" role="alert">No tables found</div>
                </div>
            </div>
            <div class="gf-form-button-row">
                <button class="btn btn-success" ng-click="updateNode()">Save</button>
            </div>
        </div>

    </div>


    <!-- TAB ADD NODE -->
    <div ng-if="data.tab == 2">

        <div class="page-header">
            <h3 class="page-heading">Choose a node name</h3>
        </div>

        <div class="gf-form-inline">
            <div class="gf-form">
                <label class="gf-form-label width-9" for="name">Name
                    <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                        Begin with one <b>letter</b> or <b>underscore</b>, followed by zero or more <b>digits</b>, <b>letters</b> and <b>underscores</b>.
                    </info-popover>
                </label>
                <input type="text" ng-pattern="/^[a-zA-Z_][0-9a-zA-Z_]*$/" class="gf-form-input min-width-10" ng-model="data.nodeSelected.name" placeholder="Node name">
            </div>
        </div>
        <div ng-if="data.nodeSelected">
            <div class="page-header">
                <h3 class="page-heading">General</h3>
            </div>
            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label width-9 multiple">Predecessors
                        <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                            Press and hold <kbd>ctrl</kbd> or <kbd>shift</kbd> and <kbd>click</kbd> on the node to select multiple nodes.
                        </info-popover>
                    </label>
                    <select class="min-width-10" name="predecessors" ng-options="node as node.name for node in data.originalNetwork.nodes" ng-model="data.predecessorList" ng-change="createCpt(); populateProbabilities()" multiple>
                        <option value="" disabled selected hidden>Choose predecessors</option>
                    </select>
                </div>

                <div class="gf-form">
                    <label class="gf-form-label width-9 multiple">Successors
                        <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                            Press and hold <kbd>ctrl</kbd> or <kbd>shift</kbd> and <kbd>click</kbd> on the node to select multiple nodes.
                        </info-popover>
                    </label>
                    <select class="min-width-10" name="successors" ng-options="node as node.name for node in data.originalNetwork.nodes" ng-model="data.successorList" multiple>
                        <option value="" disabled selected hidden>Choose successors</option>
                    </select>
                </div>
            </div>

            <div class="page-header">
                <h3 class="page-heading">States
                    <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                        <b>States number</b> indicate the number of states that will be created.<br/>
                        <b>Min</b> and <b>Max</b> are the thresholds.<br/>
                        If <b>Min</b> and <b>Max</b> are filled, the range is <b>Min&lt;X&lt;Max</b>.
                        If only <b>Min</b> is filled, the range is <b>Min&lt;X</b>.
                        If only <b>Max</b> is filled, the range is <b>X&lt;Max</b>.
                    </info-popover>
                </h3>
            </div>
            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label width-8">States number</label>
                    <input type="number" class="gf-form-input width-5" ng-model="data.numberStates" ng-change="populateStateList(); populateProbabilities()" placeholder="num">
                </div>
            </div>
            <div class="gf-form-inline" ng-repeat="index in range(data.numberStates) track by $index">
                <div class="gf-form">
                    <label class="gf-form-label width-8" for="name">State name
                        <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                            Begin with one <b>letter</b> or <b>underscore</b>, followed by zero or more <b>digits</b>, <b>letters</b> and <b>underscores</b>.
                        </info-popover>
                    </label>
                    <input type="text" ng-pattern="/^[a-zA-Z_][0-9a-zA-Z_]*$/" class="gf-form-input min-width-10" placeholder="State name" ng-model="data.stateList[$index].name">
                </div>
                <div class="gf-form">
                    <label class="gf-form-label width-4">Min</label>
                    <input type="number" class="gf-form-input width-5" placeholder="min" ng-model="data.stateList[$index].minInterval">
                </div>
                <div class="gf-form">
                    <label class="gf-form-label width-4">Max</label>
                    <input type="number" class="gf-form-input width-5" placeholder="max" ng-model="data.stateList[$index].maxInterval">
                </div>
            </div>

            <div class="page-header">
                <h3 class="page-heading">Probability table
                    <info-popover mode="left-normal" position="top center" class="gf-form-help-icon">
                        By selecting the predecessors of the node, a grid will be created with the options to set the probabilities of each state.
                    </info-popover>
                </h3>
            </div>
            <table class="table table-bordered table-dark" > <!-- ||  -->
                <thead ng-if="data.stateListCpt.length > 0">
                <tr ng-repeat="i in range(data.stateListCpt.length) track by $index" ng-init="row = $index">
                    <th>{{data.stateListCpt[row].nodeName}}</th>
                    <th colspan="{{getStateList(data.stateListCpt.length-1).length/getStateList(row).length}}" ng-repeat="j in getStateList(row) track by $index" ng-init="column = $index">{{getStateList(row)[column].name}}</th>
                </tr>
                </thead>

                <tbody ng-if="data.numberStates !== 0 || data.numberStates !== null">
                <tr ng-repeat="index in range(data.numberStates) track by $index" ng-init="row = $index">
                    <th scope="row" ng-if="data.stateList[$index].name">{{data.stateList[$index].name}}</th>
                    <th scope="row" ng-if="!data.stateList[$index].name">State name</th>
                    <td ng-repeat="j in range(getStateList(data.stateListCpt.length-1).length) track by $index" ng-init="column = $index">
                        <input type="number" class="gf-form-input" ng-model="data.probabilities[row][column]" placeholder="Ex: 0.5">
                    </td>
                </tr>
                </tbody>
            </table>

            <div class="page-header">
                <h3 class="page-heading">Sensor info</h3>
            </div>
            <div class="gf-form-inline">
                <div class="gf-form">
                    <label class="gf-form-label  width-9">Data Source
                        <info-popover mode="right-normal" position="top center" class="gf-form-help-icon">
                            <b>OPTIONAL:</b> This is the <b>database</b>, <b>table</b> and <b>column</b> used as the source of data by the selected node.
                        </info-popover>
                    </label>
                    <select name="databases"
                            ng-options="database as database.grafanaName for database in data.databaseList" ng-model="data.databaseSelected"
                            ng-change="setTableList()">
                        <option value="" disabled selected hidden>Choose database</option>
                    </select>
                    <div ng-if="data.waitingSensor && data.databaseSelected">
                        <h3><img src="/public/img/loading-pulse.svg" /> Loading...</h3>
                    </div>
                    <div ng-if="!data.waitingSensor && data.tables.length > 0">
                        <select name="tables" ng-options="table for table in data.tables" ng-model="data.tableSelected"
                                ng-change="setColumnList()">
                            <option value="" disabled selected hidden>Choose table</option>
                        </select>
                        <select name="columns" ng-options="column for column in data.columns"
                                ng-model="data.columnSelected">
                            <option value="" disabled selected hidden>Choose column</option>
                        </select>
                    </div>
                    <div ng-if="!data.waitingSensor && !(data.tables.length > 0) && data.databaseSelected" class="alert alert-warning" role="alert">No tables found</div>
                </div>
            </div>
        </div>
        <div class="gf-form-button-row">
            <button class="btn btn-success" ng-click="addNode(); refreshGraph()">Add node</button>
        </div>

    </div>

    <!-- TAB DELETE NODE -->
    <div ng-if="data.tab == 3">
        <div ng-class="{modal: true, fade: true, show: data.modalTrigger}" ng-if="data.networkSelected">
            <div class="modal-backdrop"></div>
            <div class="modal-dialog">
                <div class="modal-header">
                    <h2 class="modal-header-title">Delete</h2>
                    <a class="modal-header-close" ng-click="close()">
                        <i class="fa fa-remove"></i>
                    </a>
                </div>
                <div class="modal-content help-modal">
                    <h4>Are you sure you want to delete <b>{{data.originalNode.name}}</b> Node?</h4>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" ng-click="close(); deleteNode()">Yes</button>
                    <button class="btn btn-danger" ng-click="close()">No</button>
                </div>
            </div>
        </div>

        <div class="page-header">
            <h3 class="page-heading">Choose a node to delete</h3>
        </div>

        <div class="gf-form-inline">
            <div class="gf-form">
                <label class="gf-form-label width-9">Node</label>
                <select class="min-width-10" name="nodes" ng-options="node as node.name for node in data.originalNetwork.nodes" ng-model="data.originalNode"
                        ng-change="">
                    <option value="" disabled selected hidden>Choose node</option>
                </select>
            </div>
            <br/>
        </div>
        <div class="gf-form-button-row">
            <button class="btn btn-success" ng-click="open()">Delete node</button>
        </div>
    </div>
</div>
